SmotreshkaCore.Loader = function(host) {
    if(host) {
        this.host = host;
    }
}

SmotreshkaCore.Loader.prototype = {
    host: ".",

    appJS: [
        '/js/views/login.js',
        '/js/views/play.js',
        '/js/app.js'
    ],

    appJSConfig: [
        '/__THEME__/js/config.js',
        '/__THEME__/js/translate.js',
    ],

    theme: null,

    defaultTheme: "smotreshka",

    load: function() {
        if(!this.theme) {
            this.theme = SmotreshkaCore.Location.Helper.getHrefParams()["theme"];
        }

        if(!this.theme) {
            this.theme = this.defaultTheme;
        }

        this.loadCSS();
        this.loadHTML();
        this.loadJS();
    },

    setTheme: function(theme) {
        this.theme = theme;

        SmotreshkaCore.App.theme = this.theme;
    },

    setHost: function(host) {
        this.host = host;

        SmotreshkaCore.App.host = this.host;
    },

    loadCSS: function(callback) {
        SmotreshkaCore.Dom.Helper.addStyles([
            this.host+"/core/dist/smotreshka.core.css",
            this.host+"/assets/css/base.css",
            this.host+"/assets/css/" + SmotreshkaCore.PlatformDetector.currentPlatform.name.toLowerCase() + ".css",
            this.host+"/themes/"+this.theme+"/assets/less/theme.css"
        ], callback);
    },

    loadJS: function() {
        for(var i = 0; i < this.appJSConfig.length; i++) {
            this.appJSConfig[i] = this.host + this.appJSConfig[i].replace("__THEME__", "themes/"+this.theme);
        }

        for(var i = 0; i < this.appJS.length; i++) {
            this.appJS[i] = this.host + this.appJS[i];
        }

        SmotreshkaCore.Dom.Helper.addScripts(this.appJSConfig, function() {
            SmotreshkaCore.Dom.Helper.addScripts(this.appJS);
        }.bind(this));
    },

    loadHTML: function() {
        var hardHTMLAll = '<div id="content"> <div id="main"> <div id="preloader"> <p class="logo"> <img src="__HOST__/__THEME__/assets/images/logo.png?v=2" alt=""> </p> </div> </div> </div>';
        var hardHTMLLoginForm = '<script type="text/template" id="login_form"> <button class="login-top-button"></button> <div id="auth_form"> <div class="center" id="title_auth_form"> <p class="logo"> <img src="__HOST__/__THEME__/assets/images/logo.png?v=<%= Date.now() %>" alt=""> </p> <p class="app_name"> <%= t.nameApp %> </p> <p class="text"> <%= t.enterLogin %> </p> </div> <div class="center"> <form id="auth_form_element" autocomplete="false" onsubmit="return false"> <div class="line"> <label><%= t.login %></label> <span class="nav-item vkeyboard input" id="login_nav" data-navdown="password_nav" data-navtop="submit_nav"> <input id="login_input" autocomplete="false" type="text" name="login<%= Date.now() %>" value="" /> </span> </div> <div class="line"> <label><%= t.password %></label> <span class="nav-item vkeyboard input" id="password_nav" data-navtop="login_nav" data-navdown="submit_nav"> <input id="password_input" autocomplete="false" type="password" name="password<%= Date.now() %>" value="" /> </span> </div> <div class="line"> <span class="form-error"> </span> </div> <div class="line submit-button"> <span class="nav-item submit" id="submit_nav" data-navdown="login_nav" data-navtop="password_nav"> <%= t.enter %> </span> </div> <ul id="auth_form_errors"> </ul> </form> <div id="qrcode"> <img id="" alt="" width="200px" height="200px" src="http://<%= Config.Host %><%= qrUrl %>/qr.png?t=<%= timestamp %>" /> </div> </div> </div> </script>';

        hardHTMLAll = hardHTMLAll.replace("__THEME__", "themes/"+this.theme);
        hardHTMLLoginForm = hardHTMLLoginForm.replace("__THEME__", "themes/"+this.theme);

        hardHTMLAll = hardHTMLAll.replace("__HOST__", this.host);
        hardHTMLLoginForm = hardHTMLLoginForm.replace("__HOST__", this.host);

        document.body.innerHTML += hardHTMLAll;
        document.body.innerHTML += hardHTMLLoginForm;
    }
}

SmotreshkaCore.Loader =  new SmotreshkaCore.Loader();
