var PlayView = function() {};

PlayView.prototype = Object.assign(new SmotreshkaCore.Views.View(), {
    //
    initialize: function (options) {
        Smotreshka.channelCollection.on("sync", this.onChannelsChange.bind(this));

        this.currentChannel = new SmotreshkaCore.Store.Models.Channel();
    },

    //
    onChannelsChange: function() {
        this.createPlayer();

        var currentChannel = null;

        // если есть хотя бы один канал, указываем что смотреть надо его
        if(Smotreshka.channelCollection.model && Smotreshka.channelCollection.model.length > 0) {
            currentChannel = Smotreshka.channelCollection.model[0];
        }

        // если есть ранее просмотренные каналы, выбираем ранее просмотренный канал.
        if(Smotreshka.account.model.profile.recent_views && Smotreshka.account.model.profile.recent_views.length > 0) {
            var newCurrentChannel = Smotreshka.channelCollection.getChannelById(Smotreshka.account.model.profile.recent_views[0]);

            if(newCurrentChannel) {
                currentChannel = newCurrentChannel;
            }
        }

        if(currentChannel) {
            this.player.events.trigger("SmotreshkaCore:plugin:channel:update", {
                id: currentChannel.id
            });
        }
    },

    //
    onRender: function() {
        var playerPlace = document.createElement("div");
        playerPlace.setAttribute("id", "player_place");

        Smotreshka.content.appendChild(playerPlace);

        playerPlace = null;

        Smotreshka.channelCollection.fetch();
    },

    //
    createPlayer: function() {
        console.log(SmotreshkaCore.App);
        var params = {
            id: "player_place",
            size: {
                width: "100%",
                height: "100%"
            },
            currentChannel: this.currentChannel,
            user: Smotreshka.account,
            epgCollection: Smotreshka.epgCollection,
            channels: Smotreshka.channelCollection,
            genres: Smotreshka.genresCollection,
            approved: SmotreshkaCore.App.approvedState
        };

        var playerCreator = new SmotreshkaCore.Player.HLSSmartTVPlayer();
        this.player = playerCreator.create(params);

        this.player.events.on("Account:logout", this.logout.bind(this));
    },

    //
    logout: function() {
        document.location.reload(true);
    }
});
